## build-essential 2

=== Makefile ===

esslist := essential-packages-list
packages := /var/state/apt/lists/http.us.debian.org_debian_dists_unstable_main_binary-i386_Packages

# Only for use if you know what you're doing, after you've edited $(packages)
make-esslist :
	echo > $(esslist) 'This list was generated on $(shell LC_ALL=C date)'
	echo >> $(esslist) 'It contains a list of essential packages' \
	  '(which are also build-essential).'
	echo >> $(esslist)
	grep-status -FEssential -sPackage -ni yes $(packages) \
	  >> $(esslist)

clean :
	$(MAKE) -C hellos clean

distclean: clean
	rm -f $(shell find . -type f -name '*~')

=== hellos/Makefile ===

all :
#	Nothing to do

clean :
	rm -f *.deb *.tar.gz *.diff.gz *.dsc *.changes
	cd hello && debian/rules clean

=== debian/changelog ===
build-essential (2) unstable; urgency=low

  * list: Noted that although the list is not authoritative, it attempts
    to be accurate.
  * list2depends.lhs: Added lots of comments and restructured the program a
    little to make it more readable.
  * debian/README.build-system: New file, documenting the build system
    and especially the librules.mk file.
  * debian/rules: Don't install the list2depends program.
  * debian/rules: Made to conform to what debian/README.build-system specifies.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Mon, 29 Nov 1999 14:29:38 +0200

build-essential (1) unstable; urgency=low

  * New package.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Tue,  9 Nov 1999 14:18:34 +0200

End of change log.

=== hellos/hello/debian/changelog ===
hello-bess (1) unstable; urgency=low

  * Initial revision.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Tue,  9 Nov 1999 22:26:18 +0200

.

=== debian/control ===
Source: build-essential
Section: devel
Priority: extra
Maintainer: Antti-Juhani Kaijanaho <ajk@debian.org>
Standards-Version: 3.1.0
Build-Depends: hugs, dpkg-dev (>= 1.4.1.5)

Package: build-essential
Architecture: any
Depends: ${build-essential}
Description: Informational list of build-essential packages
 If you do not plan to build Debian packages, you don't need this
 package.  Moreover this package is not required for building Debian
 packages.
 .
 This package contains an informational list of packages which are
 considered essential for building Debian packages.  This package also
 depends on the packages on that list, to make it easy to have the
 build-essential packages installed.
 .
 If you have this package installed, you only need to install whatever
 a package specifies as its build-time dependencies to build the
 package.  Conversely, if you are determining what your package needs
 to build-depend on, you can always leave out the packages this
 package depends on.
 .
 This package is NOT the definition of what packages are
 build-essential; the real definition is in the Debian Policy Manual,
 and if this package and the manual disagree, the manual is correct.

=== hellos/hello/debian/control ===
Source: hello-bess
Maintainer: Antti-Juhani Kaijanaho <ajk@debian.org>
Section: misc
Priority: extra
Standards-Version: 3.1.0

Package: hello-bess
Architecture: any
Depends: ${shlibs:Depends}
Description: A hello world

=== debian/rules ===
#!/usr/bin/make -f

native_pkg=yes
include debian/librules.mk

esslist := essential-packages-list

debian/stamp/build:
	set -e ; echo > debian/substvars \
	 "build-essential=`./list2depends.lhs $(DEB_HOST_ARCH) < list`"
	touch $@

debian/stamp/binary/indep:
	touch $@

debian/stamp/binary/arch: debian/stamp/binary/build-essential
	touch $@

debian/stamp/binary/build-essential: package=build-essential
debian/stamp/binary/build-essential:
	$(prebinary)
	$(install_nonex) list $(docdir)
	$(install_nonex) $(esslist) $(docdir)
#	$(install_nonex) list2depends.lhs $(docdir)
#	$(install_nonex) Constants.hs $(docdir)
	$(postbinary)
	touch $@

clean:
	$(MAKE) distclean

=== hellos/hello/debian/rules ===
#!/usr/bin/make -f

install         := install -o root -g root
install_exec    := $(install) -m 0755 -s
install_nonex   := $(install) -m 0644
install_dir     := $(install) -m 0755 -d
install_script  := $(install) -m 0755
install_symlink := ln -s

gzip           := gzip -9
strip_lib      := strip --strip-unneeded

tmpdir := $(shell pwd)/debian/tmp

# These must not be :='s!
rootdir = $(tmpdir)/$(package)
ctldir = $(rootdir)/DEBIAN
bindir = $(rootdir)/usr/bin
docdir = $(rootdir)/usr/share/doc/$(package)

build: hello hello++

binary: binary-arch binary-indep

define prebinary
        $(RM) -r $(rootdir)
        $(install_dir) $(ctldir)
        $(install_dir) $(docdir)
        $(install_script) debian/prerm $(ctldir)
        $(install_script) debian/postinst $(ctldir)
        $(install_nonex) debian/copyright $(docdir)
        $(install_nonex) debian/changelog $(docdir)/changelog
        $(gzip) $(docdir)/changelog
endef

define postbinary
        chmod -R g-s $(rootdir)
        dpkg-gencontrol -isp -p$(package) -P$(rootdir)
        dpkg --build $(rootdir) ..
endef

binary-arch: package=hello-bess
binary-arch: build
	$(prebinary)
	$(install_dir) $(bindir)
	$(install_exec) hello $(bindir)
	$(install_exec) hello++ $(bindir)
	dpkg-shlibdeps $(bindir)/*
	$(postbinary)

binary-indep:
#	Nothing to do

clean:
	$(RM) hello hello++ debian/files debian/substvars
	$(RM) -r debian/tmp

## build-essential 6

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 
 esslist := essential-packages-list
-packages := /var/state/apt/lists/http.us.debian.org_debian_dists_unstable_main_binary-i386_Packages
+packages := /var/lib/apt/lists/ftp.fi.debian.org_debian_dists_testing_main_binary-i386_Packages
 
 # Only for use if you know what you're doing, after you've edited $(packages)
 make-esslist :

=== debian/changelog ===
build-essential (6) unstable; urgency=low

  * ran "make make-esslist", again.
  * debian/rules: Install list into $(sharedir),
    and install a symlink from there to $(docdir),
    closes: #134390.
  * Updated debian/librules.mk.
  * debian/control: Updated Standards-Version to 3.5.6.
  * debian/copyright: Updated copyright year list.

 -- Antti-Juhani Kaijanaho <gaia@iki.fi>  Sun, 17 Feb 2002 16:07:22 +0200

build-essential (5) unstable; urgency=low

  * list: Hurd has libc0.2-dev.  Closes: #101271.
  * ran "make make-esslist".  Partially addresses #95704.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Thu, 19 Jul 2001 19:23:08 +0300

build-essential (4) unstable; urgency=low

  * list: Make dpkg-dev requirement versioned, closes: #70736.
  * debian/control [Build-Depends]: No need to build-depend on dpkg-dev,
    since the version requirement is satisfied by the build-essential
    packages now.
  * debian/control [Description]: Reworded a little.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sat,  2 Sep 2000 17:25:43 +0300

build-essential (3) unstable; urgency=low

  * debian/rules [debian/stamp/build]: make more robust against missing
    build-time dependencies, closes: #67677
  * debian/copyright: update copyright year

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Tue, 25 Jul 2000 08:40:20 +0300

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: devel
 Priority: extra
 Maintainer: Antti-Juhani Kaijanaho <ajk@debian.org>
-Standards-Version: 3.1.0
-Build-Depends: hugs, dpkg-dev (>= 1.4.1.5)
+Standards-Version: 3.5.6
+Build-Depends: hugs
 
 Package: build-essential
 Architecture: any
@@ -25,5 +25,7 @@
  package depends on.
  .
  This package is NOT the definition of what packages are
- build-essential; the real definition is in the Debian Policy Manual,
- and if this package and the manual disagree, the manual is correct.
+ build-essential; the real definition is in the Debian Policy Manual.
+ This package contains merely an informational list, which is all
+ most people need.   However, if this package and the manual disagree,
+ the manual is correct.

=== debian/rules ===
#!/usr/bin/make -f

librules_native_pkg=yes
librules_interface=1
include debian/librules.mk

esslist := essential-packages-list

debian/stamp/build:
	./list2depends.lhs $(DEB_HOST_ARCH) < list > deps
	echo "build-essential=`cat deps`" > debian/substvars
	touch $@

debian/stamp/binary/indep:

debian/stamp/binary/arch: debian/stamp/binary/build-essential

debian/stamp/binary/build-essential: package=build-essential
debian/stamp/binary/build-essential:
	$(prebinary)
	$(install_dir) $(sharedir)
	$(install_nonex) list $(sharedir)
	$(install_symlink) ../../$(package)/list $(docdir)
	$(install_nonex) $(esslist) $(docdir)
#	$(install_nonex) list2depends.lhs $(docdir)
#	$(install_nonex) Constants.hs $(docdir)
	$(postbinary)
	touch $@

clean-build:
	rm -f deps

clean:
	$(MAKE) distclean

## build-essential 10

=== debian/changelog ===
build-essential (10) unstable; urgency=low

  * Fixed make-esslist.sh.
  * Added (empty) netbsd-i386 essential-packages-list file.
  * Remove strange \xB4 character from list, change to a '.  Closes: #199235.
  * Cleaned up package: removed {arch} cruft (moved to a subversion
    repository) and tidied and converted use of autotools to foreign
    to eliminate some unnecessary files.  Closes: #210500.
  * Removed dependency on cdbs and reverted to pure debhelper.
  * Remade essential-list files, initscripts got included.

 -- Scott James Remnant <scott@netsplit.com>  Fri, 26 Sep 2003 02:09:13 +0100

build-essential (9.7) unstable; urgency=low

  * New maintainer.

 -- Scott James Remnant <scott@netsplit.com>  Thu, 11 Sep 2003 03:13:08 +0100

build-essential (9.6) unstable; urgency=low

  * Add libc6-dev-sparc64 to list for sparc (Closes: #207770).

 -- Colin Walters <walters@debian.org>  Fri, 29 Aug 2003 12:52:09 -0400

build-essential (9.5.1) unstable; urgency=low

  * Clean and re-autogen so as to ensure that aren't using
    symlinks to the various autotools scripts (Closes: #205836).

 -- Colin Walters <walters@debian.org>  Mon, 18 Aug 2003 22:58:47 -0400

build-essential (9.5) unstable; urgency=low

  * Make ia64 use libc6.1-dev (Closes: #203238)

 -- Colin Walters <walters@debian.org>  Fri, 15 Aug 2003 22:24:55 -0400

build-essential (9.4) unstable; urgency=low

  * Pass --copy to automake-1.7 so we actually include install.sh and
    stuff (Closes: #197501).

 -- Colin Walters <walters@debian.org>  Sun, 15 Jun 2003 12:31:22 -0400

build-essential (9.3) unstable; urgency=low

  * Package is Debian-native again.
  * Switch to gcc-3.3 (Closes: #195213)
  * debian/rules:
    - Cosmetic fixes.

 -- Colin Walters <walters@debian.org>  Fri,  6 Jun 2003 23:41:12 -0400

build-essential (9.2-1) unstable; urgency=low

  * New upstream version.
  * debian/control:
    - Bump Standards-Version to 3.5.10, no changes required.
    - Add Build-Depends on cdbs.
  * debian/rules:
    - Convert to cdbs.
  * debian/rocks:
    - Removed.

 -- Colin Walters <walters@debian.org>  Mon, 21 Apr 2003 20:21:37 -0400

build-essential (9.1-1) unstable; urgency=low

  * The "It has been rumored that we have fired scud missiles into
    Kuwait. I am here now to tell you, we do not have any scud missiles
    and I don't know why they were fired into Kuwait." release.  (Courtesy
    of Mohammed Saeed Al-Sahaf).
  * New upstream release.
    - Makes ia64 use libc6.1-dev (Closes: #188444)
  * debian/rules:
    - Update to the latest version of Colin's Build System.

 -- Colin Walters <walters@debian.org>  Sun, 13 Apr 2003 23:54:57 -0400

build-essential (9-1) unstable; urgency=low

  * New upstream version.
    - Depends on gcc 3.2 (Closes: #175596)

 -- Colin Walters <walters@debian.org>  Tue,  7 Jan 2003 00:40:26 -0500

build-essential (8-1) unstable; urgency=low

  * Convert to autoconf and automake.
  * Rewrite list2depends.lhs in new Python version "list2depends".  Delete
    old Haskell version.
  * New script to generate essential pacakges list "make-esslist.sh",
    taken from old Makefile.
  * Regenerate essential packages list.
  * Remove 'hellos' test sources.
  * debian/rules:
    - Convert to Colin's Build System.
  * debian/control:
    - New maintainer (Closes: #174849).
    - Build-Depend on debhelper.
    - Drop Build-Dependency on hugs, add one on python.
    - Standards-Version: 3.5.8.
  * debian/rocks:
    - New file, converted from old debian/rules.
  * postinst.build-essential, prerm.build-essential:
    - Obsolete files, the /usr/doc transition is over.  Deleted.
  * debian/copyright:
    - Convert from obsolete national charset ISO-8859-1 into UTF-8, and
    add myself to copyright holders.

 -- Colin Walters <walters@debian.org>  Wed,  1 Jan 2003 14:50:59 -0500

build-essential (7) unstable; urgency=low

  * list: GNU/Hurd has now libc0.3-dev.  Closes: #144523.
  * Makefile, debian/rules: Make $(esslist) arch-specific and build it
    (at make-esslist time) from the official sarge Packages files off the net.
    This is as good as it'll get without net access from the build daemons.
    Closes: #95704.
  * debian/rules: Install $(esslist) into $(sharedir),
    and install a symlink from there to $(docdir), closes: #137189.
  * ran "make make-esslist"
  * debian/control: Upgrade priority to optional, following the ftpmaster lead.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Mon, 22 Jul 2002 21:21:06 +0300

## build-essential 10ubuntu1

=== debian/changelog ===
build-essential (10ubuntu1) warty; urgency=low

  * amd64 changes from debian.  Closes: #241689

 -- LaMont Jones <lamont@mmjgroup.com>  Tue, 13 Jul 2004 03:37:54 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: build-essential
 Section: devel
-Priority: extra
-Maintainer: Antti-Juhani Kaijanaho <ajk@debian.org>
-Standards-Version: 3.5.6
-Build-Depends: hugs
+Priority: optional
+Maintainer: Scott James Remnant <scott@netsplit.com>
+Standards-Version: 3.5.10
+Build-Depends: debhelper (>= 4.0), python (>= 2.1)
 
 Package: build-essential
 Architecture: any
 Depends: ${build-essential}
-Description: Informational list of build-essential packages
+Description: informational list of build-essential packages
  If you do not plan to build Debian packages, you don't need this
  package.  Moreover this package is not required for building Debian
  packages.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for the Debian build-essential package.
# Copyright © 2003 Scott James Remnant <scott@netsplit.com>

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

# Use debhelper v4 features.
export DH_COMPAT=4

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)


build: build-stamp
build-stamp: configure
	dh_testdir

	./configure --prefix=/usr
	$(MAKE)

	touch build-stamp

clean: configure
	dh_testdir
	dh_testroot
	rm -f build-stamp

	-$(MAKE) -k distclean
	rm -f config.cache config.log config.status
	rm -rf autom4te.cache

	dh_clean

# Make it as clean as svn can make it.
svnclean: clean
	rm -rf `svn propget svn:ignore`

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	$(MAKE) prefix=`pwd`/debian/build-essential/usr install

	printf > debian/build-essential.substvars "build-essential=%s\n" \
		"`./list2depends $(DEB_HOST_ARCH) < list`"

	mkdir -p debian/build-essential/usr/share/doc/build-essential
	ln -s	../../build-essential/list \
		../../build-essential/essential-packages-list \
		debian/build-essential/usr/share/doc/build-essential

# Build architecture-independent files here.
binary-indep: build install
# Nothing to do

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot

	dh_installdocs
	dh_installchangelogs
	dh_link
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean svnclean binary-indep binary-arch binary install

## build-essential 10.1

=== debian/changelog ===
build-essential (10.1) unstable; urgency=low

  * Added (empty) amd64, kfreebsd-i386, knetbsd-i386 and powerpc64
    eseential-packages-list files.

 -- Scott James Remnant <scott@netsplit.com>  Sun, 29 Aug 2004 18:49:36 +0100

## build-essential 10.1osso1

=== debian/changelog ===
build-essential (10.1osso1) unstable; urgency=low

  * armel: essential-packages-list for armel arch added

 -- Ed Bartosh <eduard.bartosh@nokia.com>  Wed, 24 May 2006 15:04:27 +0300

build-essential (10.1osso) unstable; urgency=low

  * build-dependency to python removed 

 -- Ed Bartosh <eduard.bartosh@nokia.com>  Fri, 31 Mar 2006 11:43:37 +0300

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: devel
 Priority: optional
 Maintainer: Scott James Remnant <scott@netsplit.com>
-Standards-Version: 3.5.10
-Build-Depends: debhelper (>= 4.0), python (>= 2.1)
+Standards-Version: 3.6.1.0
+Build-Depends: debhelper (>= 4.0)
 
 Package: build-essential
 Architecture: any

## build-essential 10.1ubuntu1

=== debian/changelog ===
build-essential (10.1ubuntu1) hoary; urgency=low

  * Resynchronise with Debian.

 -- Scott James Remnant <scott@canonical.com>  Wed, 27 Oct 2004 12:15:20 +0100

## build-essential 11.1

=== debian/changelog ===
build-essential (11.1) unstable; urgency=low

  * If the source doesn't ship with an essential-package-list for the
    building architecture, create an empty one instead of failing.

 -- Scott James Remnant <scott@netsplit.com>  Thu,  7 Jul 2005 19:27:01 +0100

build-essential (11) unstable; urgency=low

  * Increased versioned dependency on gcc and g++ to 4.0.
  * Increased versioned dependency on dpkg-dev to 1.13.5 to provide
    support for the OS and CPU variables.
  * Updated policy references to 3.6.1.1.  Closes: #313277.
  * Regenerated essential-package-list files.  In line with dpkg, these
    now only exist for architectures in sid, all of the empty ones have
    been removed.
    - ncurses-base added for sh (creating this file)
    - login added for hurd-i386

 -- Scott James Remnant <scott@netsplit.com>  Tue,  5 Jul 2005 17:01:26 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Scott James Remnant <scott@netsplit.com>
 Standards-Version: 3.6.1.0
-Build-Depends: debhelper (>= 4.0)
+Build-Depends: debhelper (>= 4.0), python (>= 2.1)
 
 Package: build-essential
 Architecture: any

## build-essential 11.3

=== debian/changelog ===
build-essential (11.3) unstable; urgency=low

  * Regenerate the essential packages lists, including amd64. Closes: #317336.
  * Increased versioned dependency on gcc and g++ to 4.1.1.
  * Update Standards-Version to 3.7.2. No changes required.

 -- Matthias Klose <doko@debian.org>  Mon, 10 Jul 2006 01:17:14 +0200

build-essential (11.2) unstable; urgency=low

  * New maintainer.
  * Tighten versioned dependency on gcc and g++ to the versions
    with the libstdc++ allocator change. Closes: #343028.

 -- Matthias Klose <doko@debian.org>  Sat, 28 Jan 2006 10:43:03 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: build-essential
 Section: devel
 Priority: optional
-Maintainer: Scott James Remnant <scott@netsplit.com>
-Standards-Version: 3.6.1.0
+Maintainer: Matthias Klose <doko@debian.org>
+Uploaders: Scott James Remnant <scott@netsplit.com>
+Standards-Version: 3.7.2.0
 Build-Depends: debhelper (>= 4.0), python (>= 2.1)
 
 Package: build-essential

## build-essential 11.3ubuntu1

=== debian/changelog ===
build-essential (11.3ubuntu1) gutsy; urgency=low

  * Add lpia.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 20 Jul 2007 12:42:41 +0000

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 # debian/rules for the Debian build-essential package.
-# Copyright © 2003 Scott James Remnant <scott@netsplit.com>
+# Copyright © 2003, 2004 Scott James Remnant <scott@netsplit.com>
 
 # Uncomment this to turn on verbose mode. 
 #export DH_VERBOSE=1

## build-essential 11.4

=== debian/changelog ===
build-essential (11.4) unstable; urgency=low

  * Regenerate the essential packages lists, including armel.
  * Increased versioned dependency on gcc and g++ to 4.3.1 (not alpha),
    to 4.2.4 (alpha).
  * Depend on hurd-dev [hurd-i386]. Closes: #456549.
  * Update package description. Closes: #480677.

 -- Matthias Klose <doko@debian.org>  Fri, 11 Jul 2008 01:05:30 +0200

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,16 @@
 Priority: optional
 Maintainer: Matthias Klose <doko@debian.org>
 Uploaders: Scott James Remnant <scott@netsplit.com>
-Standards-Version: 3.7.2.0
+Standards-Version: 3.8.0
 Build-Depends: debhelper (>= 4.0), python (>= 2.1)
 
 Package: build-essential
 Architecture: any
 Depends: ${build-essential}
-Description: informational list of build-essential packages
+Description: Informational list of build-essential packages
  If you do not plan to build Debian packages, you don't need this
- package.  Moreover this package is not required for building Debian
- packages.
+ package.  Starting with dpkg (>= 1.14.18) this package is required
+ for building Debian packages.
  .
  This package contains an informational list of packages which are
  considered essential for building Debian packages.  This package also

## build-essential 11.4build1

=== debian/changelog ===
build-essential (11.4build1) lucid; urgency=low

  * rebuild rest of main for armel armv7/thumb2 optimization;
    UbuntuSpec:mobile-lucid-arm-gcc-v7-thumb2

 -- Alexander Sack <asac@ubuntu.com>  Fri, 05 Mar 2010 03:11:40 +0100

## build-essential 11.5

=== debian/changelog ===
build-essential (11.5) unstable; urgency=low

  * Bump dependencies on gcc and g++ to 4.4.3.
  * Re-add explicit dependency on gcc. Closes: #536038.
  * Update essential packages lists. Closes: #545890.

 -- Matthias Klose <doko@debian.org>  Sun, 14 Mar 2010 23:03:13 +0100

=== debian/rules ===
--- 
+++ 
@@ -4,9 +4,6 @@
 
 # Uncomment this to turn on verbose mode. 
 #export DH_VERBOSE=1
-
-# Use debhelper v4 features.
-export DH_COMPAT=4
 
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

## build-essential 11.5ubuntu1

=== debian/changelog ===
build-essential (11.5ubuntu1) natty; urgency=low

  * Lists of essential packages per architecture were incorrect for Ubuntu,
    breaking sbuild (see Debian #602571).
    - update make-esslist.sh to:
      . sort packages to allow for cleaner diffs between Debian and Ubuntu or
        across updates.
      . default to `lsb_release -cs` for dist instead of sid, as the Ubuntu
        development dist changes constantly; an alternative would be the
        target dist from debian/changelog, but this is often UNRELEASED.
      . query a list of servers instead of only one; this is needed for the
        archive.u.c / ports.u.c split in Ubuntu, but it's also helpful to
        allow configuring a local mirror (which might not carry all
        architectures).  The default list is http://archive.ubuntu.com/ubuntu
        http://ports.ubuntu.com/ubuntu-ports.
    - update lists of essential packages by running make-esslist.sh.
      . clear package lists for alpha, arm, hppa, hurd-i386, ia64,
        kfreebsd-amd64, kfreebsd-i386, mips, mipsel, s390, sparc; these aren't
        supported architectures in natty.
      . add python-minimal and drop sysvinit-utils and sysvinit on amd64,
        armel, i386 and powerpc.

 -- Loïc Minier <loic.minier@ubuntu.com>  Sat, 13 Nov 2010 15:31:39 +0100

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,12 @@
 Priority: optional
 Maintainer: Matthias Klose <doko@debian.org>
 Uploaders: Scott James Remnant <scott@netsplit.com>
-Standards-Version: 3.8.0
-Build-Depends: debhelper (>= 4.0), python (>= 2.1)
+Standards-Version: 3.8.4
+Build-Depends: debhelper (>= 5.0), python (>= 2.1)
 
 Package: build-essential
 Architecture: any
-Depends: ${build-essential}
+Depends: ${build-essential}, ${misc:Depends}
 Description: Informational list of build-essential packages
  If you do not plan to build Debian packages, you don't need this
  package.  Starting with dpkg (>= 1.14.18) this package is required

## build-essential 11.5ubuntu2

=== debian/changelog ===
build-essential (11.5ubuntu2) precise; urgency=low

  * Mark build-essential Multi-Arch: foreign.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 05 Nov 2011 00:49:52 -0400

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,15 @@
 Source: build-essential
 Section: devel
 Priority: optional
-Maintainer: Matthias Klose <doko@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
 Uploaders: Scott James Remnant <scott@netsplit.com>
 Standards-Version: 3.8.4
 Build-Depends: debhelper (>= 5.0), python (>= 2.1)
 
 Package: build-essential
 Architecture: any
+Multi-Arch: foreign
 Depends: ${build-essential}, ${misc:Depends}
 Description: Informational list of build-essential packages
  If you do not plan to build Debian packages, you don't need this

## build-essential 11.5ubuntu2.1

=== debian/changelog ===
build-essential (11.5ubuntu2.1) precise; urgency=low

  * Revert the previous change, we shouldn't be foreign (LP: #1034568)

 -- Adam Conrad <adconrad@ubuntu.com>  Sun, 08 Jul 2012 15:43:24 -0600

## build-essential 11.5ubuntu3

=== debian/changelog ===
build-essential (11.5ubuntu3) quantal; urgency=low

  * Revert the previous change, build-essential shouldn't be foreign.

 -- Adam Conrad <adconrad@ubuntu.com>  Sun, 08 Jul 2012 15:43:24 -0600

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,6 @@
 
 Package: build-essential
 Architecture: any
-Multi-Arch: foreign
 Depends: ${build-essential}, ${misc:Depends}
 Description: Informational list of build-essential packages
  If you do not plan to build Debian packages, you don't need this

## build-essential 11.6ubuntu4

=== debian/changelog ===
build-essential (11.6ubuntu4) raring; urgency=low

  * Remove pkgbinarymangler from list.cross, it's not build-essential
    for native builds, so it's not build-essential for cross either.

 -- Adam Conrad <adconrad@ubuntu.com>  Sat, 12 Jan 2013 19:15:03 -0700

build-essential (11.6ubuntu3) raring; urgency=low

  * Build-depend on python3:any instead of python3.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 08 Jan 2013 18:48:27 +0100

build-essential (11.6ubuntu2) raring; urgency=low

  * Regenerate the control file.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 08 Jan 2013 17:08:50 +0100

build-essential (11.6ubuntu1) raring; urgency=low

  * Merge with Debian; remaining changes:
    - Build cross packages for arm64, armhf and powerpc.
    - Add pkgbinarymangler to the list of essential cross packages.
  * Update essential packages lists (Ubuntu archs only).

 -- Matthias Klose <doko@ubuntu.com>  Tue, 08 Jan 2013 16:38:40 +0100

build-essential (11.6) unstable; urgency=low

  * Update Standards-Version to 3.9.4.
  * Build-depend on python3 instead of python.
  * Update make-esslist.sh to consider ports archives and distros.
    Closes: #603386.
  * Update essential packages lists.
  * Build crossbuild-essential-<arch> packages for architectures
    provided in debian/cross-targets (currently all commented out).
    Closes: #693220.

 -- Matthias Klose <doko@debian.org>  Tue, 08 Jan 2013 16:33:55 +0100

build-essential (11.5ubuntu4) raring; urgency=low

  * make-esslist.sh: Manually add armhf, since it isn't in
    /usr/share/dpkg/archtable.
  * Run make-esslist.sh, adding libc-bin and removing python-minimal.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 05 Dec 2012 11:07:08 +0000

## build-essential 11.6ubuntu5

=== debian/changelog ===
build-essential (11.6ubuntu5) saucy; urgency=low

  * Add package list for AArch64.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 06 Aug 2013 19:58:36 +0200

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
 Uploaders: Scott James Remnant <scott@netsplit.com>
-Standards-Version: 3.8.4
-Build-Depends: debhelper (>= 5.0), python (>= 2.1)
+Standards-Version: 3.9.4
+Build-Depends: debhelper (>= 5.0), python3:any
 
 Package: build-essential
 Architecture: any
@@ -31,3 +31,60 @@
  This package contains merely an informational list, which is all
  most people need.   However, if this package and the manual disagree,
  the manual is correct.
+
+Package: crossbuild-essential-arm64
+Architecture: all
+Depends: ${cross-essential}, ${misc:Depends}
+Description: Informational list of cross-build-essential packages
+ If you do not plan to cross build Debian packages, you don't need
+ this package.  Starting with sbuild (>= 0.63.0) this package is
+ required for cross building Debian packages in a chroot.
+ .
+ This package contains an informational list of packages which are
+ considered essential for cross building Debian packages.  This
+ package also depends on the packages on that list, to make it easy to
+ have the cross-build-essential packages installed.
+ .
+ If you have this package installed, you only need to install whatever
+ a package specifies as its build-time dependencies to cross build the
+ package.  Conversely, if you are determining what your package needs
+ to build-depend on, you can always leave out the packages this
+ package depends on.
+
+Package: crossbuild-essential-armhf
+Architecture: all
+Depends: ${cross-essential}, ${misc:Depends}
+Description: Informational list of cross-build-essential packages
+ If you do not plan to cross build Debian packages, you don't need
+ this package.  Starting with sbuild (>= 0.63.0) this package is
+ required for cross building Debian packages in a chroot.
+ .
+ This package contains an informational list of packages which are
+ considered essential for cross building Debian packages.  This
+ package also depends on the packages on that list, to make it easy to
+ have the cross-build-essential packages installed.
+ .
+ If you have this package installed, you only need to install whatever
+ a package specifies as its build-time dependencies to cross build the
+ package.  Conversely, if you are determining what your package needs
+ to build-depend on, you can always leave out the packages this
+ package depends on.
+
+Package: crossbuild-essential-powerpc
+Architecture: all
+Depends: ${cross-essential}, ${misc:Depends}
+Description: Informational list of cross-build-essential packages
+ If you do not plan to cross build Debian packages, you don't need
+ this package.  Starting with sbuild (>= 0.63.0) this package is
+ required for cross building Debian packages in a chroot.
+ .
+ This package contains an informational list of packages which are
+ considered essential for cross building Debian packages.  This
+ package also depends on the packages on that list, to make it easy to
+ have the cross-build-essential packages installed.
+ .
+ If you have this package installed, you only need to install whatever
+ a package specifies as its build-time dependencies to cross build the
+ package.  Conversely, if you are determining what your package needs
+ to build-depend on, you can always leave out the packages this
+ package depends on.

## build-essential 11.6ubuntu6

=== debian/changelog ===
build-essential (11.6ubuntu6) trusty; urgency=low

  * Update package lists.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 26 Nov 2013 07:48:42 +0100

=== debian/control ===
--- 
+++ 
@@ -88,3 +88,22 @@
  package.  Conversely, if you are determining what your package needs
  to build-depend on, you can always leave out the packages this
  package depends on.
+
+Package: crossbuild-essential-ppc64el
+Architecture: all
+Depends: ${cross-essential}, ${misc:Depends}
+Description: Informational list of cross-build-essential packages
+ If you do not plan to cross build Debian packages, you don't need
+ this package.  Starting with sbuild (>= 0.63.0) this package is
+ required for cross building Debian packages in a chroot.
+ .
+ This package contains an informational list of packages which are
+ considered essential for cross building Debian packages.  This
+ package also depends on the packages on that list, to make it easy to
+ have the cross-build-essential packages installed.
+ .
+ If you have this package installed, you only need to install whatever
+ a package specifies as its build-time dependencies to cross build the
+ package.  Conversely, if you are determining what your package needs
+ to build-depend on, you can always leave out the packages this
+ package depends on.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for the Debian build-essential package.
# Copyright © 2003, 2004 Scott James Remnant <scott@netsplit.com>

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

cross_archs := $(shell grep -v '^\#' debian/cross-targets)

build: build-arch build-indep
build-arch: build-arch-stamp
build-indep: build-indep-stamp

debian/control: debian/control.in debian/control.cross debian/cross-targets
	cat debian/control.in > $@
	for a in $(cross_archs); do \
	  sed -e "s/@DEB_TARGET_ARCH@/$$a/g" debian/control.cross >> $@; \
	done

configure-stamp:
	dh_testdir
	./configure --prefix=/usr
	touch configure-stamp

build-arch-stamp: configure-stamp
	dh_testdir
	$(MAKE)
	touch build-arch-stamp

build-indep-stamp: configure-stamp
	dh_testdir
	for a in $(cross_archs); do \
	  t=$$(dpkg-architecture -f -a$$a -qDEB_HOST_GNU_TYPE 2>/dev/null); \
	  echo $$a $$t; \
	  sed "s/@DEB_TARGET_ARCH@/$$a/g;s/@DEB_TARGET_GNU_TYPE@/$$t/g" \
	    list.cross > list.$$a; \
	done
	touch build-indep-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f *-stamp
	rm -f config.cache config.log config.status Makefile
	rm -rf autom4te.cache
	for f in list.*; do \
	  case $$f in list|list.cross) continue; esac; \
	  rm -f $$f; \
	done
	rm -f essential-packages-list
	dh_clean

# Make it as clean as svn can make it.
svnclean: clean
	rm -rf `svn propget svn:ignore`

install-arch: build-arch
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	$(MAKE) prefix=$(CURDIR)/debian/build-essential/usr install

	printf > debian/build-essential.substvars "build-essential=%s\n" \
		"`./list2depends $(DEB_HOST_ARCH) < list`"

	mkdir -p debian/build-essential/usr/share/doc/build-essential
	ln -sf	../../build-essential/list \
		../../build-essential/essential-packages-list \
		debian/build-essential/usr/share/doc/build-essential

install-indep: build-indep
	set -e; \
	for a in $(cross_archs); do \
	  p=crossbuild-essential-$$a; \
	  $(MAKE) prefix=$(CURDIR)/debian/$$p/usr install; \
	  rm -f debian/$$p/usr/share/build-essential/essential-packages-list; \
	  rm -rf debian/$$p/usr/share/$$p; \
	  mv debian/$$p/usr/share/build-essential \
		debian/$$p/usr/share/$$p; \
	  printf > debian/$$p.substvars "cross-essential=%s\n" \
		"`./list2depends $$a < list.$$a`"; \
	  mkdir -p debian/$$p/usr/share/doc/$$p; \
	  ln -sf ../../$$p/list debian/$$p/usr/share/doc/$$p; \
	done

binary-arch: build-arch install-arch
	dh_testdir
	dh_testroot
	dh_installdocs -a
	dh_installchangelogs -a
	dh_link -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary-indep: build-indep install-indep
	dh_testdir
	dh_testroot
ifneq (,$(cross_archs))
	dh_installdocs -i
	dh_installchangelogs -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i
endif

binary: binary-indep binary-arch
.PHONY: build-arch build-indep clean svnclean \
    binary-indep binary-arch binary install-arch install-indep
